#!/usr/bin/python

"""
Copyright (C) 2005 Robert Clark

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
"""

from Tkinter import *		#This import the Tk interface
import os
import ConfigParser

###############################################################
#               Configuration Options                         #
serviceList = ['ssh','proftpd']                              #
openWordList = ['opened']                                    #
closedWordList = ['closed']                                  #
badWordList = ['Illegal','Invalid']                          #
highlightWordList = ['cheese']				     #
fileToOpen = "/var/log/messages"                             #
###############################################################
try:
	config = ConfigParser.SafeConfigParser()
	config.read('thumper.conf')
	fileToOpen = config.get("config","fileToOpen")
	serviceList = config.get("config","services").split(",")
	openWordList = config.get("config","openWords").split(",")
	closedWordList = config.get("config","closedWords").split(",")
	badWordList = config.get("config","badWords").split(",")
	highlightWordList = config.get("config","highlightWords").split(",")
except:
	print "Error in config file, reverting to defaults"

root = Tk()			#This creates a window
root.title('Thumper')

services = str(serviceList)
label = Label(root, text=services)
label.pack()

textbox = Text(root)
scroll = Scrollbar(root, command=textbox.yview)
textbox.configure(yscrollcommand=scroll.set)
scroll.pack(side=RIGHT, fill=Y)
textbox.pack(fill=BOTH,expand='yes')




textbox.tag_config('bad_tag',foreground='red')
textbox.tag_config('open_tag',foreground='black')
textbox.tag_config('closed_tag',foreground='blue')
textbox.tag_config('highlight_tag',foreground='purple')

logList = []
displayList = []

file = open(fileToOpen, "r")
logList = file.readlines()

y = 0
end = ".0"
index = '0.0'

for line in logList:
	for service in serviceList:
		if line.find(service) >=0:
			displayList.append(line)
	for word in highlightWordList:
		if line.find(word) >=0:
			displayList.append(line)

for record in displayList:
	for word in openWordList:
		if record.find(word) >= 0:
			textbox.insert('0.0',record,'open_tag')

	for word in closedWordList:
		if record.find(word) >= 0:
			textbox.insert('0.0',record,'closed_tag')

	for word in badWordList:
		if record.find(word) >= 0:
			textbox.insert('0.0',record,'bad_tag')
	
	for word in highlightWordList:
		if record.find(word) >= 0:
			textbox.insert('0.0',record,'highlight_tag')

root.mainloop()


